<script>
import Heading from "./components/Heading.vue";
import PapercutsFilter from "./components/PapercutsFilter.vue";
import Papercut from "./components/Papercut.vue";
import TopBar from "./components/TopBar.vue";
import { GlLoadingIcon } from "@gitlab/ui";

export default {
  components: { Heading, PapercutsFilter, Papercut, TopBar, GlLoadingIcon },
  data() {
    return {
      milestones: [],
      currentMilestone: null,
      papercuts: [],
    };
  },
  mounted() {
    const urlParams = new URLSearchParams(window.location.search);
    const milestoneFromUrl = urlParams.get("milestone");

    fetch("data/papercuts/milestones.json")
      .then((res) => res.json())
      .then((milestones) => {
        this.milestones = milestones;

        if (milestoneFromUrl && milestones.map(m => m.title).includes(milestoneFromUrl)) {
          this.currentMilestone = milestoneFromUrl;
        } else {
          this.currentMilestone = milestones[0].title;
        }

        this.fetchPapercuts();
      });
  },
  methods: {
    milestoneChanged(milestone) {
      this.currentMilestone = milestone;
      this.fetchPapercuts();
      this.setUrl(milestone);
      window.scrollTo({ top: 0 });
    },
    setUrl(milestone) {
      const newUrl = new URL(window.location);
      newUrl.searchParams.set("milestone", milestone);
      window.history.pushState({ path: newUrl.href }, "", newUrl.href);
    },
    fetchPapercuts() {
      fetch(`data/papercuts/${this.currentMilestone}.json`)
        .then((res) => res.json())
        .then((papercuts) => (this.papercuts = papercuts));
    },
  },
};
</script>

<template>
  <div id="app" class="gl-max-w-container-xl gl-px-6 gl-mx-auto">
    <TopBar>
      <div
        class="gl-text-subtle gl-flex gl-items-center gl-gap-3"
        v-if="milestones.length === 0 || currentMilestone === null"
      >
        Loading <GlLoadingIcon />
      </div>
      <div v-else>
        <PapercutsFilter
          :milestones="milestones"
          :currentMilestone="currentMilestone"
          @milestoneChanged="milestoneChanged"
        />
      </div>
    </TopBar>
    <Heading />

    <div
      v-if="milestones.length === 0 || currentMilestone === null"
      class="gl-text-subtle gl-flex gl-items-center gl-justify-center gl-w-full gl-my-11"
    >
      <GlLoadingIcon size="lg" />
    </div>
    <div v-else>
      <Papercut
        v-for="papercut in papercuts"
        :key="papercut.mergeRequestId"
        :papercut="papercut"
      />
      <div
        class="gl-text-subtle gl-my-7 gl-flex gl-flex-col gl-gap-3 gl-items-center"
      >
        <hr class="gl-w-8 gl-my-4" />
        <div>That's all for milestone {{ currentMilestone }}!</div>

        <div class="gl-flex gl-gap-3 gl-items-center">
          <div>Browse other milestones:</div>
          <PapercutsFilter
            hideLabel
            :milestones="milestones"
            :currentMilestone="currentMilestone"
            @milestoneChanged="milestoneChanged"
          />
        </div>
      </div>
    </div>
  </div>
</template>
